
/*
 * Progetto 6 del Capitolo 6 del libro Savitch.
 * 
 * I sistemi tradizionali di inserimento delle password sono 
 * soggetti al cosiddetto shoulder surfing, nel quale qualcuno
 * osserva un utente ingnaro mentre inserisce una password o
 * un PIN e li utilizza successivamente per accedere all'account.
 * Un modo per combattere questo problema  utilizzare un
 * sistema basato su coppie domanda-risposta generate in modo
 * casuale.
 * In tali sistemi, l'utente deve fornire ogni volta informazioni
 * diverse in risposta a un quesito generato in maniera casuale.
 * Si consideri lo schema seguente, nel quale la password consiste
 * in un PIN a cinque cifre (da 00000 a 99999).
 * Ad ogni cifra  associato un numero casuale scelto tra 1, 2 e 3.
 * L'utente inserir, al posto del PIN vero e proprio, i numeri
 * casuali corrispondenti alle cifre del PIN.
 * Per esempio, si supponga che il vero PIN sia 12345.
 * In fase di autenticazione, all'utente verr mostrata una
 * schermata come:
 * 
 * PIN: 	0 1 2 3 4 5 6 7 8 9
 * NUM: 	3 2 3 1 1 3 2 2 1 3
 * 
 * A questo punto, l'utente inserir il numero 23113 al posto di 12345.
 * In questo modo, la password non viene svelata nemmeno se
 * qualcuno vede cosa viene inserito, perch 23113 potrebbe 
 * corrispondere anche a molti altri PIN, come 69440 o 70439.
 * Al successivo accesso verr generata una sequenza diversa di 
 * numeri casuali come:
 * 
 * PIN: 	0 1 2 3 4 5 6 7 8 9
 * NUM: 	1 1 2 3 1 2 2 3 3 3
 * 
 * Si scriva un programma che simuli la procedura di autenticazione,
 * inserendo un PIN direttamente nel codice.
 * Il programma dovrebbe utilizzare un array per associare i numeri
 * casuali alle cifre da 0 a 9.
 * Inoltre, dovr mostrare sullo schermo i numeri casuali, leggere 
 * la risposta dell'utente e comunicare se la risposta dell'utente
 *  corretta o meno.
 * 
 */

import java.util.*;

public class ShoulderSurfing {
	
	public static final int CIFRE = 10;
	public static final int CIFRE_PIN = 5;
	public static final int CIFRE_CODIFICA = 3;
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		
		int[] PIN = {1,2,3,4,5}; // PIN prefissato
		int[] NUM = new int[CIFRE];
		
		// generazione dei numeri casuali
		for(int i=0; i<CIFRE; i++)
			NUM[i] = (int)(Math.random()*CIFRE)%CIFRE_CODIFICA+1;
		
		System.out.print("PIN:\t");
		for(int i=0; i<CIFRE;i++)
			System.out.print(i+" ");
		System.out.println();
		
		System.out.print("NUM:\t");
		visualizza(NUM);
		
		System.out.print("Inserisci il PIN (5 cifre): ");
		String pin = tastiera.next();
		int[] pin_estratto = estraiPIN(pin);
		
		boolean corrisponde = verificaPIN(pin_estratto,PIN,NUM);
		
		if(corrisponde)
			System.out.println("Il codice inserito  corretto");
		else
			System.out.println("Il codice inserito non  corretto");
		
		tastiera.close();
		
	}
	
	public static void visualizza(int[] v){
		for(int i=0; i<v.length;i++)
			System.out.print(v[i]+" ");
		System.out.println();
		
	}
	
	public static int[] estraiPIN(String pin){
		int[] estratto = new int[CIFRE_PIN];
		for(int i=0;i<pin.length();i++)
			estratto[i] = Integer.parseInt(pin.substring(i,i+1));
		return estratto;
	}
	
	public static boolean verificaPIN(int[] inserito, int[] registrato, int codifica[]){
		boolean corretto=true;
		int i=0;
		while(i<CIFRE_PIN && corretto){
			if(inserito[i]!=codifica[registrato[i]])
				corretto = false;
			i++;
		}
		return corretto;
	}

}
